--SavedVariables: RedeemernoTargetQuotes, RedeemerhunterQuotes, RedeemercombatQuotes, RedeemerwarlockQuotes, RedeemerselfQuotes, RedeemerengineerQuotes, RedeemerghoulQuotes, RedeemernoghoulQuotes, RedeemermassQuotes, RedeemerotherQuotes, RedeemerCurrentVersion
--SavedVariablesPerCharacter: RedeemerDisplaySay, RedeemerDisplayParty, RedeemerDisplayRaid, RedeemerDisplayWhisper

--The "RedeemerxxQuotes" variables store the user's copies of the quotes for
--each spell. "xxQuotes" variables, without the Redeemer prefix, refer to the
--default quote lists in the "RedeemerQuotes.lua" file.

--Master version number listing. Should be consistent with what the download site listed.
REDEEMER_CURRENT_VERSION = GetAddOnMetadata("Redeemer", "Version")
QUOTELIST_NAMES = {
    'noTargetQuotes',
    'hunterQuotes',
    'combatQuotes',
    'warlockQuotes',
    'selfQuotes',
    'engineerQuotes',
    'ghoulQuotes',
    'noghoulQuotes',
    'massQuotes',
    'otherQuotes',
};


function Redeemer_OnLoad(self)
	
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("UNIT_SPELLCAST_SENT");
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	self:RegisterEvent("PLAYER_DEAD");
	self:RegisterEvent("PLAYER_ALIVE");
	
	SLASH_REDEEMER1 = "/redeemer";
	SlashCmdList["REDEEMER"] = Redeemer_SlashOpts;
end

function RedeemerUIPanel_Update()
        RedeemerUIPanelSay:SetChecked(_G["RedeemerDisplaySay"]);
        RedeemerUIPanelParty:SetChecked(_G["RedeemerDisplayParty"]);
        RedeemerUIPanelRaid:SetChecked(_G["RedeemerDisplayRaid"]);
        RedeemerUIPanelWhisper:SetChecked(_G["RedeemerDisplayWhisper"]);
end

function Redeemer_GetDefaultQuotes(category)
    --takes the name of an xxQuotes variable found in the RedeemerQuotes.lua
    --file, as a string
    --this is probably a boneheaded implementation, but not enough to make me
    --change it right now
    return _G[category];
end

function Redeemer_OnEvent(self, event, ...)
	
	if (event == "ADDON_LOADED") then
		local addon = select(1, ...);
		if (addon == "Redeemer") then
            --if quote variables are nil, load defaults
            for i, name in ipairs(QUOTELIST_NAMES) do
                if (_G["Redeemer"..name] == nil) then
                    _G["Redeemer"..name] = Redeemer_GetDefaultQuotes(name);
                    DEFAULT_CHAT_FRAME:AddMessage("Default quotes imported: |cffffffff"..name, 0.25, 0.88, 0.88);
                end
            end
            if (RedeemerCurrentVersion == nil) then --probably a first-time installation
                RedeemerCurrentVersion = REDEEMER_CURRENT_VERSION;
                DEFAULT_CHAT_FRAME:AddMessage("Redeemer version |cffffffff"..RedeemerCurrentVersion, 0.25, 0.88, 0.88);
            end
			DEFAULT_CHAT_FRAME:AddMessage("Redeemer is locked and loaded!", 0.25, 0.88, 0.88);
			--if an option setting is not found, set it to default
			if (RedeemerDisplaySay == nil) then
				DEFAULT_CHAT_FRAME:AddMessage("Redeemer /say option default  set |cffffffff[|cff00ff00on|cffffffff]", 0.25, 0.88, 0.88);
				RedeemerDisplaySay = true;
			end
			if (RedeemerDisplayParty == nil) then
				DEFAULT_CHAT_FRAME:AddMessage("Redeemer /party option default set |cffffffff[|cffff0000off|cffffffff]", 0.25, 0.88, 0.88);
				RedeemerDisplayParty = false;
			end
			if (RedeemerDisplayRaid == nil) then
				DEFAULT_CHAT_FRAME:AddMessage("Redeemer /raid option default set |cffffffff[|cffff0000off|cffffffff]", 0.25, 0.88, 0.88);
				RedeemerDisplayRaid = false;
			end
			if (RedeemerDisplayWhisper == nil) then
				DEFAULT_CHAT_FRAME:AddMessage("Redeemer /whisper option default set |cffffffff[|cffff0000off|cffffffff]", 0.25, 0.88, 0.88);
				RedeemerDisplayWhisper = false;
			end
		end
	end
	
	if (event == "UNIT_SPELLCAST_SENT") then
		local unitID, spellName, _, target = ...;
			--arg3, rank, was deprecated in 4.0
		--[[
		DEFAULT_CHAT_FRAME:AddMessage(tostring(event));
		DEFAULT_CHAT_FRAME:AddMessage(tostring(unitID));
		DEFAULT_CHAT_FRAME:AddMessage(tostring(spellName));
		DEFAULT_CHAT_FRAME:AddMessage(tostring(target));
		]]--
		if (unitID == "player") then
			if (spellName == "Redemption") then
				Redeemer_Quotes("Paladin", target);
			elseif (spellName == "Resurrection") then
				Redeemer_Quotes("Priest", target);
			elseif (spellName == "Ancestral Spirit") then
				Redeemer_Quotes("Shaman", target);
			elseif (spellName == "Revive") then
				Redeemer_Quotes("Druid", target);
			elseif (spellName == "Revive Pet") then
				if (PET_NAME) then
					Redeemer_Quotes("Hunter", PET_NAME);
				else
					SendChatMessage("Pet Name unknown!");
				end
			elseif (spellName == "Rebirth") then
				Redeemer_Quotes("Combat", target);
			elseif (spellName == "Defibrillate") then
				Redeemer_Quotes("Engineer", target);
			elseif (spellName == "Raise Dead") then
				Redeemer_Quotes("DeathKnightDead", target);
			elseif (spellName == "Raise Ally") then
				Redeemer_Quotes("DeathKnightAlly", target)
			elseif (spellName == "Soulstone Resurrection") then
				Redeemer_Quotes("Warlock", target);
			elseif (spellName == "Mass Resurrection") then
				Redeemer_Quotes("Mass", "");
			end
		end
	end
	
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		local _, event_name, _, _, _, _, _, _, destName, destFlags, _ = ...;
		--[[
		DEFAULT_CHAT_FRAME:AddMessage(tostring(event));
		DEFAULT_CHAT_FRAME:AddMessage(string.format("0x%x",tostring(timestamp)));
		DEFAULT_CHAT_FRAME:AddMessage(tostring(event_name));
		DEFAULT_CHAT_FRAME:AddMessage(tostring(hideCaster));
		DEFAULT_CHAT_FRAME:AddMessage(tostring(sourceGUID));
		DEFAULT_CHAT_FRAME:AddMessage(tostring(sourceName));
		DEFAULT_CHAT_FRAME:AddMessage(string.format("0x%x",tostring(sourceFlags)));
		DEFAULT_CHAT_FRAME:AddMessage(string.format("0x%x",tostring(sourceRaidFlags)));
		DEFAULT_CHAT_FRAME:AddMessage(string.format("0x%x",tostring(destGUID)));
		DEFAULT_CHAT_FRAME:AddMessage(tostring(destName));
		DEFAULT_CHAT_FRAME:AddMessage(string.format("0x%x",tostring(destFlags)));
		DEFAULT_CHAT_FRAME:AddMessage(tostring(destRaidFlags));
		]]--
		--if pet dies, gets pet's name
		if (event_name == "UNIT_DIED") then
			if (destFlags == 0x1111) then
				PET_NAME = destName;
			end
		end
	end
	
	if (event == "PLAYER_DEAD") then
		if (HasSoulstone()) then
			RedeemerHasSoulstone = true;
		end
	end
	
	if (event == "PLAYER_ALIVE") then
		if (RedeemerHasSoulstone) then
			RedeemerHasSoulstone = false;
			Redeemer_Quotes("Self", "self");
		end
	end
	
end


function Redeemer_Quotes(playerClass, target)
	
	--DEFAULT_CHAT_FRAME:AddMessage("Redeemer called: " .. playerClass .. target);
	--SendChatMessage("Redeemer called!");
	local chatMessage;
    local quoteSource;
    if (string.upper(target) == "UNKNOWN") then
        quoteSource = RedeemernoTargetQuotes;
	elseif (playerClass == "Mass") then
        quoteSource = RedeemermassQuotes;
	elseif (playerClass == "Hunter") then
        quoteSource = RedeemerhunterQuotes;
	elseif (playerClass == "Combat") then
        quoteSource = RedeemercombatQuotes;
	elseif (playerClass == "Engineer") then
        quoteSource = RedeemerengineerQuotes
	elseif (playerClass == "Warlock") then
        quoteSource = RedeemerwarlockQuotes;
	elseif (playerClass == "Self") then
        quoteSource = RedeemerselfQuotes;
	elseif (playerClass == "DeathKnightDead") then
        quoteSource = RedeemernoghoulQuotes;
	elseif (playerClass == "DeathKnightAlly") then
        quoteSource = RedeemerghoulQuotes;
	else
        quoteSource = RedeemerotherQuotes;
	end
    if (#(quoteSource) > 0) then    --preventing Lua errors for empty quote categories
        chatMessage = quoteSource[random(#(quoteSource))];
        
        chatMessage = string.gsub(chatMessage, "%%t", target);
        
        Redeemer_SendQuotes(chatMessage, target);
    end
	--quote = quote + 1;
	
end

function Redeemer_SendQuotes(chatMessage, target)

	if (RedeemerDisplayRaid and UnitInRaid("player")) then
		SendChatMessage(chatMessage, "RAID");
	elseif (RedeemerDisplayParty and GetNumPartyMembers() > 0) then
		SendChatMessage(chatMessage, "PARTY");
	elseif (RedeemerDisplaySay) then
		SendChatMessage(chatMessage, "SAY");
	end
	
	if (RedeemerDisplayWhisper and string.upper(target) ~= "UNKNOWN") then
		SendChatMessage(chatMessage, "WHISPER", nil, target);
	end
	
end

function Redeemer_SlashOpts(cmd)

	cmd = string.lower(cmd);
	
	if (cmd == "say") then
		RedeemerDisplaySay = not RedeemerDisplaySay;
		sayText = "|cffffffff[";
		if (RedeemerDisplaySay) then
			sayText = sayText.."|cff00ff00on";
		else
			sayText = sayText.."|cffff0000off";
		end
		sayText = sayText.."|cffffffff]";
		DEFAULT_CHAT_FRAME:AddMessage("Quotes sent to /say toggled "..sayText, 0.25, 0.88, 0.88);
		
	elseif (cmd == "party") then
		RedeemerDisplayParty = not RedeemerDisplayParty;
		partyText = "|cffffffff[";
		if (RedeemerDisplayParty) then
			partyText = partyText.."|cff00ff00on";
		else
			partyText = partyText.."|cffff0000off";
		end
		partyText = partyText.."|cffffffff]";
		DEFAULT_CHAT_FRAME:AddMessage("Quotes sent to /party toggled "..partyText, 0.25, 0.88, 0.88);
		
	elseif (cmd == "raid") then
		RedeemerDisplayRaid = not RedeemerDisplayRaid;
		raidText = "|cffffffff[";
		if (RedeemerDisplayRaid) then
			raidText = raidText.."|cff00ff00on";
		else
			raidText = raidText.."|cffff0000off";
		end
		raidText = raidText.."|cffffffff]";
		DEFAULT_CHAT_FRAME:AddMessage("Quotes sent to /raid toggled "..raidText, 0.25, 0.88, 0.88);
	
	elseif (cmd == "whisper") then
		RedeemerDisplayWhisper = not RedeemerDisplayWhisper;
		whisperText = "|cffffffff[";
		if (RedeemerDisplayWhisper) then
			whisperText = whisperText.."|cff00ff00on";
		else
			whisperText = whisperText.."|cffff0000off";
		end
		whisperText = whisperText.."|cffffffff]";
		DEFAULT_CHAT_FRAME:AddMessage("Quotes whispered to target toggled "..whisperText, 0.25, 0.88, 0.88);
		
	else
		sayText = "|cffffffff[";
		if (RedeemerDisplaySay) then
			sayText = sayText.."|cff00ff00on";
		else
			sayText = sayText.."|cffff0000off";
		end
		sayText = sayText.."|cffffffff]";
		partyText = "|cffffffff[";
		if (RedeemerDisplayParty) then
			partyText = partyText.."|cff00ff00on";
		else
			partyText = partyText.."|cffff0000off";
		end
		partyText = partyText.."|cffffffff]";
		raidText = "|cffffffff[";
		if (RedeemerDisplayRaid) then
			raidText = raidText.."|cff00ff00on";
		else
			raidText = raidText.."|cffff0000off";
		end
		raidText = raidText.."|cffffffff]";
		whisperText = "|cffffffff[";
		if (RedeemerDisplayWhisper) then
			whisperText = whisperText.."|cff00ff00on";
		else
			whisperText = whisperText.."|cffff0000off";
		end
		whisperText = whisperText.."|cffffffff]";
		DEFAULT_CHAT_FRAME:AddMessage("/redeemer say: Toggle sending quotes to /say "..sayText, 0.25, 0.88, 0.88);
		DEFAULT_CHAT_FRAME:AddMessage("/redeemer party: Toggle sending quotes to /party "..partyText, 0.25, 0.88, 0.88);
		DEFAULT_CHAT_FRAME:AddMessage("/redeemer raid: Toggle sending quotes to /raid "..raidText, 0.25, 0.88, 0.88);
		DEFAULT_CHAT_FRAME:AddMessage("/redeemer whisper: Toggle whispering quotes to target "..whisperText, 0.25, 0.88, 0.88);
	end
	RedeemerUIPanel_Update();
	--DEFAULT_CHAT_FRAME:AddMessage("Command: "..cmd);
	
end

--Interface Options Panel functions
function RedeemerUIPanelOnLoad(panel)
    panel.name = "Redeemer "..REDEEMER_CURRENT_VERSION;
    panel.refresh = function(self) RedeemerUIPanel_Update(); end;
    panel.okay = function(self) RedeemerUIPanel_Okay(); end;
    panel.cancel = function(self) RedeemerUIPanel_Update(); end;
    panel.default = function(self) RedeemerUIPanel_Default(); end;
    InterfaceOptions_AddCategory(panel);
end

function RedeemerUIPanel_Default()
    RedeemerDisplaySay = true;
    RedeemerDisplayParty = false;
    RedeemerDisplayRaid = false;
    RedeemerDisplayWhisper = false;
end

function RedeemerUIPanel_Okay()
    RedeemerDisplaySay = Redeemer_YesOrNo(RedeemerUIPanelSay);
    RedeemerDisplayParty = Redeemer_YesOrNo(RedeemerUIPanelParty);
    RedeemerDisplayRaid = Redeemer_YesOrNo(RedeemerUIPanelRaid);
    RedeemerDisplayWhisper = Redeemer_YesOrNo(RedeemerUIPanelWhisper);
end

function Redeemer_YesOrNo(checkbox)
    --checkbox:GetChecked() returns 1 or nil, which isn't quite what I want
    if (checkbox:GetChecked() == nil) then
        return false;
    else
        return true;
    end
end

